package org.acme.getting.started;

import io.quarkus.runtime.ShutdownEvent;
import io.quarkus.runtime.StartupEvent;
import org.jboss.logging.Logger;

import javax.enterprise.context.ApplicationScoped;
import javax.enterprise.event.Observes;
import javax.inject.Inject;

@ApplicationScoped
public class AppLifecycleBean {

    private static final Logger LOGGER = Logger.getLogger("ListenerBean");

    @Inject
    MyThreadExecutor scheduledExecutor;

    void onStart(@Observes StartupEvent ev) {
        LOGGER.info("The application is starting...");

        scheduledExecutor.scheduleDataFileTask();
    }

    void onStop(@Observes ShutdownEvent ev) {
        LOGGER.info("The application is stopping...");

        try {
            scheduledExecutor.shutdownNow();
        } catch (SecurityException ex) {
            LOGGER.warn("Error shutting down Executor service...", ex);
        }
    }

}
